/*
 *  TOPPERS/ASP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Advanced Standard Profile Kernel
 *
 *  Copyright (C) 2008 by Embedded and Real-Time Systems Laboratory
 *              Graduate School of Information Science, Nagoya Univ., JAPAN
 *
 *  嵭Ԥϡʲ(1)(4)ξ˸¤ꡤܥեȥ
 *  ܥեȥѤΤޤࡥʲƱˤѡʣ
 *  ѡۡʰʲѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *      ޤܥեȥΥ桼ޤϥɥ桼Τʤ
 *      ͳ˴Ťᤫ⡤嵭ԤTOPPERSץȤ
 *      դ뤳ȡ
 * 
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơλŪ
 *  ФŬޤơʤݾڤԤʤޤܥեȥ
 *  ѤˤľŪޤϴŪʤ»˴ؤƤ⡤
 *  Ǥʤ
 * 
 *  @(#) $Id: avalon_timer.c 1 2010-06-14 02:33:52Z ertl-ichiba $
 */

/*
 *  ޥɥ饤СAvalon Timer
 */

#include "kernel_impl.h"
#include "time_event.h"
#include <sil.h>
#include "target_timer.h"
#include "avalon_timer.h"
 
/*
 *  ޤεư
 */
void
target_timer_initialize(intptr_t exinf)
{
	CLOCK cyc = TO_CLOCK(TIC_NUME, TIC_DENO);

	/* ޡȥå */
	sil_wrw_iop((void*)AVALON_TIM_CONTROL, AVALON_TIM_CONTROL_STOP);
	/* ॢȥơꥢ */
	sil_wrw_iop((void*)AVALON_TIM_STATUS, 0x00);

    assert(cyc <= MAX_CLOCK);                          /* ޾ͤΥå */
    sil_wrw_iop((void*)AVALON_TIM_PERIODL, (cyc & 0xffff)); /* 󥿡å 16bit */
    sil_wrw_iop((void*)AVALON_TIM_PERIODH, (cyc >> 16));    /* 󥿡å 16bit */

    /*
     * ޡȡȥɡߵ
     */
    sil_wrw_iop((void*)AVALON_TIM_CONTROL, AVALON_TIM_CONTROL_START
                                 |AVALON_TIM_CONTROL_COUNT|AVALON_TIM_CONTROL_ITO);
}

/*
 *  ޤ߽
 */
void
target_timer_terminate(intptr_t exinf)
{
	/*  */
	sil_wrw_iop((void*)AVALON_TIM_CONTROL, AVALON_TIM_CONTROL_STOP);

	/* ׵Υꥢ */
	sil_wrw_iop((void*)AVALON_TIM_STATUS, 0x00);
}

/*
 *  ޳ߥϥɥ
 */
void
target_timer_handler(void)
{
	/* TOӥåȤΥꥢ */
	sil_wrw_iop((void*)AVALON_TIM_STATUS,0x00);

	i_begin_int(INTNO_TIMER);
	/* ƥåζ */
	signal_time();
	i_end_int(INTNO_TIMER);
}
